"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isActive = void 0;
const assert_1 = __importDefault(require("assert"));
const React = __importStar(require("react"));
function isActive(props) {
    const { view } = props;
    const { selection } = view.state;
    const paragraph = view.domAtPos(selection.$from.pos);
    return props.isActive && !!paragraph.node;
}
exports.isActive = isActive;
class LinkToolbar extends React.Component {
    constructor() {
        super(...arguments);
        this.menuRef = React.createRef();
        this.state = {
            left: -1000,
            top: undefined,
        };
        this.handleOnSelectLink = ({ href, title }) => {
            const { view, onClose } = this.props;
            console.log(`handleOnSelectLink`, href, title);
            onClose();
            this.props.view.focus();
            const { dispatch, state } = view;
            let { from, to } = state.selection;
            assert_1.default(from === to);
            if (this.props.searchTriggerOpen) {
                this.props.resetSearchTrigger && this.props.resetSearchTrigger();
                dispatch(view.state.tr.delete(from - 2, from));
                from = from - 2;
                to = to - 2;
            }
            dispatch(view.state.tr
                .insertText(title, from, to)
                .addMark(from, to + title.length, state.schema.marks.link.create({ href })));
        };
    }
    get suggestedLinkTitle() {
        const { state } = this.props.view;
        const selectionText = state.doc.cut(state.selection.from, state.selection.to).textContent;
        return selectionText.trim() || "";
    }
    render() {
        const { LinkFinder } = this.props;
        return isActive(this.props) && LinkFinder ? (React.createElement(LinkFinder, { callback: this.handleOnSelectLink, newSearchTerm: this.suggestedLinkTitle, onClose: this.props.onClose })) : null;
    }
}
exports.default = LinkToolbar;
//# sourceMappingURL=LinkToolbar.js.map