"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const outline_icons_1 = require("outline-icons");
function blockMenuItems(dictionary) {
    return [
        {
            name: "image",
            title: "Upload image, audio, video, PDF",
            icon: outline_icons_1.ImageIcon,
            keywords: "picture photo",
            memberOnly: true,
        },
        {
            name: "sketch",
            title: "Sketch",
            icon: outline_icons_1.HighlightIcon,
            keywords: "sketch drawing scratchpad",
            memberOnly: true,
        },
        {
            name: "link",
            title: "Link note",
            icon: outline_icons_1.LinkIcon,
            keywords: "link url uri href",
            shortcut: "[[",
        },
        {
            name: "separator",
        },
        {
            name: "checkbox_list",
            title: dictionary.checkboxList,
            icon: outline_icons_1.TodoListIcon,
            keywords: "checklist checkbox task",
            shortcut: "[ ]",
        },
        {
            name: "bullet_list",
            title: dictionary.bulletList,
            icon: outline_icons_1.BulletedListIcon,
            shortcut: "-",
        },
        {
            name: "ordered_list",
            title: dictionary.orderedList,
            icon: outline_icons_1.OrderedListIcon,
            shortcut: "1.",
        },
        {
            name: "table",
            title: dictionary.table,
            icon: outline_icons_1.TableIcon,
            attrs: { rowsCount: 3, colsCount: 3 },
        },
        {
            name: "blockquote",
            title: dictionary.quote,
            icon: outline_icons_1.BlockQuoteIcon,
            shortcut: ">",
        },
        {
            name: "code_block",
            title: dictionary.codeBlock,
            icon: outline_icons_1.CodeIcon,
            shortcut: "```",
            keywords: "script",
        },
        {
            name: "math_inline",
            title: dictionary.math,
            icon: outline_icons_1.MathIcon,
            shortcut: "$$",
            keywords: "math latex equation",
        },
        {
            name: "separator",
        },
        {
            name: "heading",
            title: dictionary.h1,
            keywords: "h1 heading1 title",
            icon: outline_icons_1.Heading1Icon,
            shortcut: "#",
            attrs: { level: 1 },
        },
        {
            name: "heading",
            title: dictionary.h2,
            keywords: "h2 heading2",
            icon: outline_icons_1.Heading2Icon,
            shortcut: "##",
            attrs: { level: 2 },
        },
        {
            name: "heading",
            title: dictionary.h3,
            keywords: "h3 heading3",
            icon: outline_icons_1.Heading3Icon,
            shortcut: "###",
            attrs: { level: 3 },
        },
    ];
}
exports.default = blockMenuItems;
//# sourceMappingURL=block.js.map