"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prosemirror_state_1 = require("prosemirror-state");
const prosemirror_inputrules_1 = require("prosemirror-inputrules");
const Extension_1 = __importDefault(require("../lib/Extension"));
const OPEN_REGEX = /^(.*)?\[\[$/;
class SearchTrigger extends Extension_1.default {
    get name() {
        return "search";
    }
    get plugins() {
        return [
            new prosemirror_state_1.Plugin({
                props: {},
            }),
        ];
    }
    inputRules() {
        return [
            new prosemirror_inputrules_1.InputRule(OPEN_REGEX, (state, match) => {
                if (match) {
                    this.options.onOpen(match[1] || "");
                }
                return null;
            }),
        ];
    }
}
exports.default = SearchTrigger;
//# sourceMappingURL=SearchTrigger.js.map